Educational Codeforces Round 156 (Rated for Div. 2) - B+C

B. Fear of the Dark

其实刚开始我想到了需要考虑o点和p点同时包含在a圆或者b圆中的情况;也考虑到了相切的情况

但是后来看题解后发现,在相切的时候,还需要满足o点和p点能够被包含在a圆或者b圆中

cpp 复制代码
#include <math.h>
#include <stdio.h>
#include <cstring>
#include <iostream>
using namespace std;
const int N = 1e6 + 10;
#define de(x) cout << x << " ";
// int n, m, ans;
double px, py, ax, ay, bx, by;
double dis(double x1, double y1, double x2, double y2) {
    return sqrt(1.0 * (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}
void solve() {
    cin >> px >> py >> ax >> ay >> bx >> by;
    double ao = dis(0, 0, ax, ay);
    double bo = dis(0, 0, bx, by);
    double ap = dis(px, py, ax, ay);
    double bp = dis(px, py, bx, by);
    double ab = dis(ax, ay, bx, by);
    double ans = 1e9;
    ans = min(ans, max(ao, ap));  // 表示o点和p点在a圆中
    ans = min(ans, max(bo, bp));  // 表示o点和p点在b圆中
    // 表示o点和p点分别在a圆或者b圆中,此时还需要满足相切的条件
    ans = min(ans, max(ab / 2, max(ap, bo)));
    ans = min(ans, max(ab / 2, max(ao, bp)));
    printf("%.10lf\n", ans);
}
int main() {
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}

C. Decreasing String

看了官方题解才写出来,很巧妙

思路见代码注释

cpp 复制代码
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define sf(x) scanf("%d", &x);
#define de(x) cout << x << " ";
#define Pu puts("");
const int N = 2e4 + 9, mod = 1e9 + 7;
// int n, m;
string s;
ll pos;
ll len;
stack<char> q;
void solve() {
    cin >> s >> pos;
    pos--;  // 注意下标是从0开始的
    len = s.size();
    while (!q.empty())
        q.pop();
    bool ok = (pos < len);
    s += '$';  // 很小的ascll码
    for (auto c : s) {
        while (!ok && !q.empty() && q.top() > c) {
            pos -= len;  // 核心,使用线性的复杂度
            // 我们只需要动一个就已经处理了当前长度len下的字符串
            // 而且前面已经在栈中的我们不需要动,因为下一个len-1长度下
            // 需要在栈中已有元素的基础上进行
            len--;
            q.pop();
            if (pos < len)
                ok = true;  // 如果
        }
        q.push(c);
    }
    string tmp = "";
    while (!q.empty())
        tmp += q.top(), q.pop();

    reverse(tmp.begin(), tmp.end());  // 注意这里需要翻转
    // 因为我们得到的字符串是从后往前的

    cout << tmp[pos];
}
int main() {
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
相关推荐
视觉小萌新16 分钟前
VScode+opencv——关于opencv多张图片拼接成一张图片的算法
vscode·opencv·算法
2的n次方_27 分钟前
二维费用背包问题
java·算法·动态规划
simple_ssn1 小时前
【C语言刷力扣】1502.判断能否形成等差数列
c语言·算法·leetcode
寂静山林1 小时前
UVa 11855 Buzzwords
算法
Curry_Math1 小时前
LeetCode 热题100之技巧关卡
算法·leetcode
ahadee1 小时前
蓝桥杯每日真题 - 第10天
c语言·vscode·算法·蓝桥杯
军训猫猫头2 小时前
35.矩阵格式的一到一百数字 C语言
c语言·算法
Mr_Xuhhh3 小时前
递归搜索与回溯算法
c语言·开发语言·c++·算法·github
SoraLuna3 小时前
「Mac玩转仓颉内测版12」PTA刷题篇3 - L1-003 个位数统计
算法·macos·cangjie
爱吃生蚝的于勒5 小时前
C语言内存函数
c语言·开发语言·数据结构·c++·学习·算法